package cz.upol.jj1.seminar4;

public record Circle(Point center, int radius, String color) {

    //staticky atribut je ok
    static int circlesCreated = 0;

    //ale instanci atribut by neprosel
    // double area; //zkuste odkomentovat

    // Prepsany implicitni konstruktor
    // vsimnete si jine hlavicky a toho, ze radius uz ma hodnotu
    public Circle {
        if (radius <= 0) {
            throw new IllegalArgumentException("Radius has to be positive."); // vyjimka, zatim nereste
        }
    }

    //staticke metody jsou ok
    static int getCirclesCreated(){
        return circlesCreated;
    }

    static void setCirclesCreated(int count){
        circlesCreated = count;
    }

    //instnacni metody jsou ok
    public boolean contains(Point p){
        return center.distanceFrom(p) <= radius;
    }
}
