package cz.upol.jj1.seminar4;

public record Point(int x, int y) {

    //instancni metoda
    public double distanceFrom(Point p){
        return Math.sqrt(Math.abs(x  - p.x())^2 + Math.abs(y - p.y())^2);
    }
}

//to same jako trida

//import java.util.Objects;
//
//public final class Point {  //final - protoze recordy nelze dedit
//    private final int x;      //final - protoze atributy recordu jsou nemenne
//    private final int y;
//
//    public int x(){       // gettery - u recordu generovane
//        return x;
//    }
//
//    public int y(){
//        return y;
//    }
//
//    public Point(int x, int y){  // konstruktor - u recordu generovany kanonicky
//        this.x = x;
//        this.y = y;
//    }
//
//    public double distanceFrom(Point p){
//        return Math.sqrt(Math.abs(x  - p.x())^2 + Math.abs(y - p.y())^2);
//    }
//
//    @Override                         //toString, hashCode a equals - u recordu generovane
//    public String toString(){
//        return "Point[" + "x=" + x + ", y=" + y + "]";
//    }
//
//    @Override
//    public boolean equals(Object o) {
//        if (this == o) return true;
//        if (o == null || getClass() != o.getClass()) return false;
//        Point point = (Point) o;
//        return x == point.x && y == point.y;
//    }
//
//    @Override
//    public int hashCode() {
//        return Objects.hash(x, y);
//    }
//}
