package cz.upol.jj1.seminar4;

public class Main {

    public static void main(String[] args) {
        Circle c = new Circle(new Point(0, 0), 10, "r");
        Circle c2 = new Circle(new Point(0, 0), 10, "r");
        Circle c3 = new Circle(new Point(1, 1), 10, "r");
        System.out.println(c.radius());
        System.out.println(c.toString()); //recordy maji implicitne "rozumny" toString
        System.out.println(c.equals(c2)); //recordy maji implicitni equals a hashCode (po slozkach)
        System.out.println(c.equals(c3));

        System.out.println(getMinMax());


    }

    //S recordy se da pracovat lokalne:
    //lokalni ve tride
    private record MinMaxTuple(int min, int max) {
    }

    public static MinMaxTuple getMinMax() {
        int min = Integer.MAX_VALUE;
        int max = Integer.MIN_VALUE;

        //lokalni v metode
        record Triplet(int fst, int snd, int trd) {
            int compute() {
                return fst * snd * trd;
            }
        }

        for (var i = 0; i < 3; i++) {
            for (var j = 0; j < 3; j++) {
                for (var k = 0; k < 3; k++) {
                    var val = (new Triplet(i, j, k)).compute();
                    min = Math.min(min, val);
                    max = Math.max(max, val);
                }
            }
        }
        return new MinMaxTuple(min, max);
    }
}
